/*
Programm: Aufg.08.3
Zweck:    Programm zum Ueben der Ueberladung von Prfix- und Postfixoperator
          als Elementoperator und freier Operator
Aufgabe:  Entspricht der Aufgabe 3 Blatt 8 der Uebungsaufgaben zur Vorlesung 
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2002-11-26
*/

#include <iostream>
using namespace std;

class Modulo5 {
  friend Modulo5 operator++(Modulo5 &,int); //mit int-Argument als 2. Argument: Postfix-Operator ist gemeint
  private:
    int _data;
  public:
    Modulo5();
    Modulo5 operator--(); //ohne int-Argument: Praefix-Operator ist gemeint
    void show();
};

Modulo5::Modulo5() :_data(0) {
}

Modulo5 Modulo5::operator--() {
  _data--;
  if (_data == -1)
    _data = 4;
  return *this;
}

void Modulo5::show() {
  cout << _data << endl;
}

Modulo5 operator++(Modulo5 &mod5, int i) {
  Modulo5 result;
  result._data = mod5._data; //Postfix: alten Wert zurckliefern, dann erhhen; also zwischenspeichern
  ++mod5._data;
  if (mod5._data == 5)
    mod5._data = 4;
  return result;
}

int main() {
  Modulo5 mod5;
  (mod5++).show(); //schreibt 0, erhoeht auf 1
  (mod5++).show(); //schreibt 1, erhoeht auf 2
  mod5.show();     //schreibt 2
  (--mod5).show(); //erniedrigt auf 1, schreibt 1
  mod5.show();     //schreibt 1
}

