/*
Programm: Aufg.10.3
Zweck:    Schreibtischtest eines vorgegebenen Programms und Korrektur
          darin enthaltener Speicherlecks.
Aufgabe:  Entspricht der Aufgabe 3 Blatt 10 der Uebungsaufgaben zur Vorlesung
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003. Diese Lsung
          entspricht im Wesentlichen der von Prof. Henrich ausgeteilten
          Musterlsung.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2003-01-22
*/

#include <iostream>
using namespace std;

class A {
  public:
    int i;
    A():i(5) {}
    A(const A& a0) { i=a0.i; }
};

class B {
  public:
    int j;
    B() : j(6) {}
    virtual ~B() {};
};

class C : public B {
  public:
    int* ip;
    A a;
    C() { ip=new int(7); }
    C(const C& c0) : B(c0), a(c0.a) { ip = new int(*c0.ip); }
    void show() { cout << " i: " << a.i << " j: " << j << " *ip: " << *ip << endl; }
    virtual ~C() { delete ip; }
};

int main() {
  C* cp = new C;
  (*cp).show();
  (*cp).a.i=55;
  (*cp).j=66;
  *(*cp).ip=77;
  C c2=(*cp);
  delete cp;
  B* bp = new C;
  delete bp; //virtueller Destruktor ~C() wird aufgerufen
  c2.show();
}
