/*
Gegeben sind die Definitionen folgender Klassen:

class myint{int i;
public:	myint(int j=0):i(j){}
		   void show(){cout<<i;}

};

class compl{int re,im;
public:	compl(int r=0,int i=0):re(r),im(i){}
		   void show(){cout<<re<<im<<"   ";}

};

Erstellen Sie eine Schablonenklasse, die einen Vektor der Dimension 2
eines variablen Datentyps enthlt. Erstellen Sie in dieser Klasse eine
Funktion show() zur Ausgabe aller Daten am Bildschirm sowie einen
Operator + der eine Instanz zurckgibt mit dem Summenvektor als Summe
der Komponenten der einzelnen Instanzvektoren.
Bsp.:	(3,5) + (4,7) = (7,12)
		(2+3i,5+6i) + (3+4i,6+7i) = (5+7i,11+13i)
Erweitern Sie gegebenenfalls die Definitionen der gegebenen Klassen.
Geben Sie in main() einen Test des Operators+ sowie von show() mit dem
Datentyp myint an.
*/


#include <iostream.h>
#include <conio.h>

class myint{
	int i;
public:
	myint(int j=0):i(j){}
    void show(){cout<<i;}

    myint operator+(myint mi){return myint(i+mi.i);}
};

class compl{
	int re;
    int im;
public:
	compl(int r=0,int i=0):re(r),im(i){}	// Fehler falls keine Default
    void show(){cout<<re<<im<<"   ";}
    compl operator+(compl c){return compl(re+c.re,im+c.im);}
};

template <class T> class X{
	T t[2];
public:
	X(T tt1,T tt2){t[0]=tt1;t[1]=tt2;}
   void show(){t[0].show();t[1].show();cout<<endl;}
	X<T> operator+(X<T> x1){
   return X<T>(t[0].operator+(x1.t[0]),t[1].operator+(x1.t[1]));
   }
};


void main(){
	X<myint> xi(myint(5),myint(6));
    xi.show();
	X<myint> xi2(myint(7),myint(8));
	xi2.show();
	(xi+xi2).show();
    cout<<"kompl"<<endl;
    X<compl> xc(compl(1,2),compl(3,4));
    xc.show();
    X<compl> xc2(compl(11,22),compl(33,44));
    xc2.show();
	cout<<"Summe"<<endl;
    (xc+xc2).show();
    getch();
}

