/*
Programm: Aufg.09.2
Zweck:    Programm zum Ueben der dopppelten Ueberladung des Indexoperators
          [].
Aufgabe:  Entspricht der Aufgabe 2 Blatt 9 der Uebungsaufgaben zur Vorlesung
          "Programmierung 3" bei Prof. Henrich im WS 2002/2003.
Autor:    Mattias Ansorg <matthias@ansorgs.de>
Lizenz:   public domain
Datum:    2002-12-03
*/

#include <iostream>
using namespace std;

class innen {
  public:
    innen();
    int& operator[](int j);
    void show();
  private:
    int i[2];
};

class matrix {
  public:
    matrix();
    innen& operator[](int j);
    void show();
  private:
    innen i[2];
};

innen::innen() {
  i[0]=0;
  i[1]=0;
}

int& innen::operator[](int j) {
  return i[j];
}

void innen::show() {
  cout << i[0] << "  " << i[1] << endl;
}

matrix::matrix() {
}

innen& matrix::operator[](int j) {
  return i[j];
}

void matrix::show() {
  i[0].show();
  i[1].show();
}

int main() {
  matrix m; //erstellt eine 2 x 2 Matrix 
  m[0][0]=11;
  m[0][1]=22;
  m[1][0]=33;
  m[1][1]=44;
  m.show();  //gibt aus:
             //  11 22
             //  33 44
}
